SystemOrganization addCategory: #'Idiom-Exercise'!

TestCase subclass: #IdiomTest
	instanceVariableNames: 'customerBook johnLennon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest methodsFor: 'testing' stamp: 'mhopp 4/24/2013 13:22'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds
	
	customerBook := CustomerBook  new.
	
	
	self assert: ([ customerBook addCustomerNamed: 'John Lennon'] timeToRun) < 50.
! !

!IdiomTest methodsFor: 'testing' stamp: 'mhopp 4/24/2013 13:26'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	
	
		  
	customerBook  := CustomerBook new.
	johnLennon:= 'JohnLennon'.
	customerBook addCustomerNamed:  johnLennon.
	self assert: ([customerBook  removeCustomerNamed: johnLennon] timeToRun) < 100.
	
! !

!IdiomTest methodsFor: 'testing' stamp: 'mhopp 4/24/2013 16:58'!
test03CanNotAddACustomerWithEmptyName 
			
	customerBook := CustomerBook new.


	  [customerBook addCustomerNamed: ''] ifError: [ :err :rcv| 	
			self assert: err  = ( 'Error: ', CustomerBook customerCanNotBeEmptyErrorMessage).
			self assert: customerBook isEmpty ]! !

!IdiomTest methodsFor: 'testing' stamp: 'mhopp 4/24/2013 17:18'!
test04CanNotRemoveAndInvalidCustomer
	
			
	| |
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	
	[customerBook removeCustomerNamed: 'Paul McCartney'.] ifError: [ :err :rcv| 
			self assert: ((err  findString:  'NotFound') = 1 ).
			self assert: customerBook numberOfCustomers = 1.
			self assert: (customerBook includesCustomerNamed: johnLennon) ]
! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !
